#Copyright 2003 George Peter Staplin
package provide SDynObject 1.0

proc __sd.instance {obj args} {
 sd.get.array $obj objAr
 set argsLen [llength $args]
 if {1 == $argsLen} {
  return [set objAr([lindex $args 0])]
 } elseif {2 == $argsLen} {
  foreach {key value} $args {}
  set objAr($key) $value
  return $value
 } else {
  return -code error "$obj key ?value?"
 }
}

proc sd.copy.all.methods {_from_ srcObj _to_ destObj} {
 if {![info exists [sd.dereference $::__sdMasterObject $srcObj.method.name.list]]} {
  puts stderr "warning: $srcObj has no methods to copy to $destObj" 
  return
 }
 foreach m [$::__sdMasterObject $srcObj.method.name.list] {
  foreach {argList body} [$::__sdMasterObject $srcObj.method.$m] {}
  sd.new.method $m for $destObj takes $argList $body
 } 
}

proc sd.copy.method {m _from_ srcObj _to_ destObj} {
 foreach {argList body} [$::__sdMasterObject $srcObj.method.$m] {}
 sd.new.method $m for $destObj takes $argList $body
}

proc sd.copy.object {srcObj _to_ destObj} {
 sd.copy.variables from $srcObj to $destObj
 sd.copy.all.methods from $srcObj to $destObj
}

proc sd.copy.variables {_from_ srcObj _to_ destObj} {
 sd.get.array $srcObj srcAr
 sd.get.array $destObj destAr
 foreach {v value} [array get srcAr] {
  set destAr($v) $value
 }
}

proc sd.dereference {objId v} {
 return "::__sd_internal_[set objId]($v)"
}

proc sd.destroy.object obj { 
 if {[info exists [sd.dereference $::__sdMasterObject $obj.method.name.list]]} {
  foreach m [$::__sdMasterObject $obj.method.name.list] {
   unset [sd.dereference $::__sdMasterObject $obj.method.$m]
   catch {rename $obj->$m {}}
  }
  unset [sd.dereference $::__sdMasterObject $obj.method.name.list]
 }
 sd.get.array $obj objAr
 array unset objAr
 catch {rename $obj {}}
}

proc sd.get.array {n arName} {
 uplevel [list upvar #0 __sd_internal_$n $arName] 
}

proc sd.get.unique.command.name {} {
 while 1 {
  set n cmd[clock clicks]
  if {"" == [info commands $n]} {
   return $n
  }
 }
}

proc sd.new.method {m _for_ obj _takes_ argList body} {
 set modBody "set self $obj\n"
 append modBody $body 
 proc $obj->$m $argList $modBody
 $::__sdMasterObject $obj.method.$m [list $argList $body]
 lappend [sd.dereference $::__sdMasterObject $obj.method.name.list] $m
}

proc sd.new.object {} {
 set n [sd.get.unique.command.name]
 interp alias {} $n {} __sd.instance $n
 return $n
}
set ::__sdMasterObject [sd.new.object]